﻿using System;
using System.Runtime.InteropServices;

namespace VisTool
{
    public delegate void HotkeyEventHandler(int HotKeyID);

    public class SystemHotKey : System.Windows.Forms.IMessageFilter
    {
        static System.Collections.Generic.Dictionary<UInt32, IntPtr> keyIDs = new System.Collections.Generic.Dictionary<UInt32, IntPtr>();
        //IntPtr hWnd;

        public event HotkeyEventHandler OnHotkey;


        [DllImport("user32.dll")]
        public static extern UInt32 RegisterHotKey(IntPtr hWnd, UInt32 id, UInt32 fsModifiers, UInt32 vk);
        [DllImport("user32.dll")]
        public static extern UInt32 UnregisterHotKey(IntPtr hWnd, UInt32 id);
        [DllImport("kernel32.dll")]
        public static extern UInt32 GlobalAddAtom(String lpString);
        [DllImport("kernel32.dll")]
        public static extern UInt32 GlobalDeleteAtom(UInt32 nAtom);

        //public SystemHotKey(IntPtr hWnd)
        UInt32 hotkeyid;
        public SystemHotKey()
        {
            //this.hWnd = hWnd;
            System.Windows.Forms.Application.AddMessageFilter(this);
        }

        public int RegisterHotkey(System.Windows.Forms.Keys Key, IntPtr hWnd, int keyflags)
        {
            hotkeyid = GlobalAddAtom(System.Guid.NewGuid().ToString());

            try
            {
                if (RegisterHotKey((IntPtr)hWnd, hotkeyid, (UInt32)keyflags, (UInt32)Key) != 0)
                {
                    keyIDs.Add(hotkeyid, hWnd);
                }
                else
                {
                    System.Windows.Forms.MessageBox.Show(Key.ToString() + " is registed by another application", 
                        "Registering " + Key.ToString() + " failed", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);

                }
            }
            catch
            {
                System.Windows.Forms.MessageBox.Show("Registering " + Key.ToString() + " as the Refresh key failed. It is being used by another application");
            }
            return (int)hotkeyid;
        }

        protected bool UnregisterHotkeys()
        {
            #region oldversion
            try
            {
                foreach (var key in keyIDs)
                {
                    UnregisterHotKey(key.Value, key.Key);
                    GlobalDeleteAtom(key.Key);
                }
                keyIDs.Clear();
                return true;
            }
            catch 
            {
                return false;
            }
            #endregion


        }
        public bool UnregisterHotkey()
        {
            #region oldversion
            try
            {
                if (keyIDs.ContainsKey(this.hotkeyid))
                {
                    UnregisterHotKey(keyIDs[hotkeyid], this.hotkeyid);
                    GlobalDeleteAtom(this.hotkeyid);
                    keyIDs.Remove(hotkeyid);
                    hotkeyid = 0;
                }
                return true;
            }
            catch
            {
                return false;
            }
            #endregion


        }
       

        public bool PreFilterMessage(ref System.Windows.Forms.Message m)
        {
            if (m.Msg == 0x312)
            {
                if (OnHotkey != null)
                {
                    if (keyIDs.ContainsKey((UInt32)m.WParam) )
                    {
                            OnHotkey((int)m.WParam);
                            return true;
                    }
                    
                }
            }
            return false;
        }
    }
}