﻿using System;
using System.Collections.Generic;
using System.Drawing;
using VisTool;
using uVisStudio.VisDesigner;

namespace uVisStudio
{
    public class TemplateHandler { // Remove this class completely and replace with simple calls.
        public static event EventHandler<TemplateEventArgs> TemplateSelected;
        public static event EventHandler<InstanceEventArgs> InstanceSelected;

        public static void SelectTemplate(Template template) {
            // Simply calls TemplateSelected. Why this event stuff?
            TemplateSelected.Invoke(template, new TemplateEventArgs(template));
        }

        public static void SelectTemplate(Template template, uVisStudio.VisPropertyBox.StudioGrid grid) {
            InstanceSelected.Invoke(template, new InstanceEventArgs(null, grid));
        }

        public static void SelectTemplate(VisComponent instance, uVisStudio.VisPropertyBox.StudioGrid grid) {
            if (instance != null) {
                var template = instance.tpl;
                InstanceSelected.Invoke(template, new InstanceEventArgs(instance, grid));
            }
        }

        public static void SelectTemplate(VisComponent instance) {
            if (instance != null) {
                var template = instance.tpl;
                InstanceSelected.Invoke(template, new InstanceEventArgs(instance));
            }
        }
    }

    public sealed class TemplateEventArgs : EventArgs {
        public readonly Template template;

        public TemplateEventArgs(Template template) {
            this.template = template;
        }
    }

    public sealed class InstanceEventArgs : EventArgs {
        public readonly VisComponent Instance;
        public readonly uVisStudio.VisPropertyBox.StudioGrid grid;

        public InstanceEventArgs(VisComponent instance, uVisStudio.VisPropertyBox.StudioGrid grid) {
            this.Instance = instance;
            this.grid = grid;
        }

        public InstanceEventArgs(VisComponent instance) {
            this.Instance = instance;
        }
    }
}
