﻿using System;
using System.IO;
using System.Windows.Forms;
using VisTool;
using UserControl = System.Windows.Controls.UserControl;

namespace uVisStudio.VisExplorer
{
	public partial class VisExplorerMenu : UserControl
	{
        public static event EventHandler DirectoryOpened;
        private Controller controller = Controller.Instance;

        public VisExplorerMenu()
		{
			this.InitializeComponent();

            //this.newFileImage.Source = Properties.Resources.NewFolderHS.GetImage();
		    this.existingFileImage.Source = Properties.Resources.openHS.GetImage();
            this.Background = ColorConstants.MenuBackGround();
		}

		private void NewFileButtonClick(object sender, System.Windows.RoutedEventArgs e)
		{
			var visFileDialog = new VisFileDialog();
            visFileDialog.directoryTextBox.Text = VisEngine.ApplicationDirectory;
			visFileDialog.ShowDialog();
		}

        private void ExistingFileButtonClick(object sender, System.Windows.RoutedEventArgs e)
        {
            var openFileDialog = new OpenFileDialog {Title = "Select application (.vism) or initial Form (.vis)"};
            var filter = "All(*.vism; *.vis)| *.vism; *.vis";
            openFileDialog.Filter = filter;
            openFileDialog.RestoreDirectory = true;

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                var path = openFileDialog.FileName;
                var directory = Path.GetDirectoryName(path);
                this.controller.AddFolder(path);
                DirectoryOpened.Invoke(directory, new EventArgs());
            }
        }
	}
}