﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Forms;

namespace uVisStudio.VisExplorer
{
	public partial class VisFileDialog : Window
	{
	    private Controller controller = Controller.Instance;

		public VisFileDialog()
		{
			this.InitializeComponent();
		    this.Background = ColorConstants.DialogWindowBackground();
		}

        private void BrowseButtonClick(object sender, RoutedEventArgs e)
        {
            var folderBrowserDialog = new FolderBrowserDialog {Description = "Select directory"};
            if (folderBrowserDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                var directory = folderBrowserDialog.SelectedPath;
                this.directoryTextBox.Text = directory;
            }
        }

        private void OkButtonClick(object sender, RoutedEventArgs e)
        {
            this.Close();

            var fileName = this.fileNameTextBox.Text;
            var fileType = this.GetFileType();
            var file = fileName + "." + fileType;

            this.controller.CreateFile(file);
        }

        private void CancelButtonClick(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private string GetFileType()
        {
            var comboBoxItem = (ComboBoxItem)this.fileTypeComboBox.SelectedItem;
            var typeName = (string) comboBoxItem.Content;

            if (typeName.ToUpper().EndsWith("VISM"))
                return "VISM";
            if (typeName.ToUpper().EndsWith("VIS"))
                return "VIS";

            // Should not happen
            return "VIS";
        }
	}
}